#include "globals.h"

/**
 * Read the HTML rows from the pipe and write an
 * HTML table in a complete HTML page to stdout.
 * @param fd array of pipe file ids.
 */
void child(int fd[])
{
    size_t n = BUFFER_SIZE;
    char *buffer = malloc(n);

    // Close the unused WRITE end of the pipe.
    close(fd[WRITE_FD]);

    // Write the start of the HTML page and table to stdout.
    printf("<html>\n");
    printf("<body>\n");
    printf("<table border='1'>\n");
    printf("    <tr>\n");
    printf("        <th>Start</th><th>End</th>");
    printf("<th>First</th><th>Middle</th><th>Last</th>\n");
    printf("    </tr>\n");
    fflush(stdout);

    // Loop to read from the pipe.
    for (;;)
    {
        // Read pipe content into the buffer and write it to stdout.
        ssize_t size = read(fd[READ_FD], buffer, BUFFER_SIZE);
        write(WRITE_FD, buffer, size);

        if (size < BUFFER_SIZE) break;
    }

    // Write the end of the HTML table and page to stdout.
    printf("</table>\n");
    printf("</body>\n");
    printf("</html>\n");

    free(buffer);

    // Close the READ end of the pipe.
    close(fd[READ_FD]);
}
